# $Id: config.rb,v 1.1.1.1 2000/11/23 10:34:06 not Exp $

# Configuration file class

require 'delegate'

class Config < SimpleDelegator

  attr_reader :config

  def initialize
    @config = {}
    super(@config)
  end

  def set(key, value)
    if @config.key?(key) and @config[key].kind_of?(Array) then
      @config[key] << value
    else
      @config[key] = value
    end
  end
  
  public
  def load(filename)
    file = open(filename)
    begin
      file.each{ |line|
        if /^(\w+)\s*=\s*(.+)$/ =~ line then
          begin
            set($1.strip, eval($2.strip.tosjis))
          rescue             # ςȂ͕̂ƂĈ
            set($1.strip, $2.strip.tosjis)
          rescue ScriptError # ςȂ͕̂ƂĈ (ruby 1.5.x ?)
            set($1.strip, $2.strip.tosjis)
          end
        end
      }
    rescue Errno::ENOENT
      $stderr.print "\n** Can't open Configuration file: '#{filename}'\n"
      exit
    ensure
      file.close
    end
  end

  def setarray(*keys)
    keys.each{ |key|
      if @config.key?(key) and !@config[key].kind_of?(Array) then
        @config[key] = [@config[key]]
      else
        @config[key] = []
      end
    }
  end

  def Config::load(filename)
    config = Config::new
    config.load(filename)
    config
  end
  
end


