# $Id: topic.rb,v 1.2 2000/12/21 23:01:23 not Exp $

# gsbNꗗ쐬NX
class Topics
  attr_accessor :logDirectory
  attr_accessor :outputDirectory
  attr_accessor :showVersion
  attr_accessor :filename
  attr_accessor :monthPartNames
  attr_accessor :regexp
  attr_accessor :pattern
  attr_accessor :replace
  attr_accessor :outputKcode
  attr_accessor :monthPartNames

  def initialize
    @topic            = ''
    @topicMonthFormat = '%YN%0m'
    @topicDateFormat  = '%0d(%e)'
    @regexp  = ''
    @pattern = ''
    @replace = ''
    @outputKcode      = 1
  end

  def topicMonthFormat=(str)
    @topicMonthFormat = str unless str.nil?
  end

  def topicDateFormat=(str)
    @topicDateFormat = str unless str.nil?
  end

  def load
    topic = {}
    Dir[@logDirectory + '[0-9]' * 6 + '.topic'].each{ |filename|
      open(filename){ |file|
        file.each{ |line|
          t = line.chomp.split(/\t/)
          date = t.shift
          topic[date[0..5]] = {} unless topic.key?(date[0..5])
          topic[date[0..5]][date[6..7]] = t
          for i in 0...t.size
            t[i].gsub!(/<.+?>/, '')
            t[i] = ["#{date[0..5]}#{@monthPartNames[date[6..7].to_i]}.html##{date[6..7]}_t#{i+1}", t[i]]
          end
        }
      }
    }
    @topic = Marshal::dump(topic)
  end


  def tohtml(diarys, putmonth = true)
    load if @topic.empty?
    body = ''
    regexp  = Regexp::compile(@regexp)
    pattern = Regexp::compile(@pattern)
    monthPartNames = @monthPartNames[1..31].uniq

    topic = Marshal::load(@topic)

    topic.delete_if{ |month, days|
      days.delete_if{ |date, topics|
        topics.delete_if{ |line| regexp !~ line[1] }
        topics.size.zero? or !diarys.include?(month + date)
      }
      days.size.zero?
    }
    
    topic.keys.sort.reverse.each{ |month|
      if putmonth then
        m = Time::local(month[0..3], month[4..5])
        if monthPartNames.size == 1 then
          body << "\t<dt><a name=\"#{month}\" href=\"#{month}#{monthPartNames[0]}.html\">"
          body << "#{m.strftime2(@topicMonthFormat)}</a></dt>\n\t<dd><ul>\n"
        else
          body << "\t<dt><a name=\"#{month}\">#{m.strftime2(@topicMonthFormat)}</a> ( "
          monthPartNames.each{ |part|
            if File::readable?(@outputDirectory + "#{month}#{part}.html") then
              body << "<a href=\"#{month}#{part}.html\">#{part}</a> "
            else
              body << "#{part} "
            end
          }
          body << ")</dt>\n\t<dd><ul>\n"
        end
      end
        
      topic[month].keys.sort.each{ |date|
        d = Time::local(month[0..3], month[4..5], date)
        body << "\t\t<li>#{d.strftime2(@topicDateFormat)} : "
        body << topic[month][date].collect!{ |t|
          "<a href=\"#{t[0]}\">#{t[1].gsub(pattern, @replace)}</a>"
        }.join(' / ')
        body << "</li>\n"
      }
      body << "</ul>\n" if putmonth
    }

    if putmonth then
      return "<dl>\n" + body + "</dl>\n"
    else
      return "<ul>\n" + body + "</ul>\n"
    end
  end

  def writeHTML(diarys, putmonth = true)

    @outputKcode = 1 if (@outputKcode < 1 or @outputKcode > 3)

    out = open(@outputDirectory + @filename, "w")

    begin
      infile = open(@logDirectory + @filename)
      infile.each { |line|
        if line.gsub!(/<!--body-->/i, "") then
          out.print tohtml(diarys, putmonth).kconv(@outputKcode)
        end
        out.print line.kconv(@outputKcode)
      }
      infile.close

      out.close
    rescue Errno::ENOENT
      $stderr.puts "\n** error: topics skelton file: '#{@logDirectory + @filename}' not found.\n"
      return
    end
    print "make '#{@outputDirectory + @filename}'\n"
  end
end

