# $Id: calendar.rb,v 1.2 2000/12/15 14:53:00 not Exp $

=begin

  calendar.rb

    nDiary Plug-in  J_[̍쐬

    etւ̃Nt̃J_[쐬܂B

    option:
      lang=en         Atp\Lɂ܂B

      exsample:
        <!--plug=calendar?lang=en-->

=end


def plug(opt)
  require 'date'

  if self.kind_of?(LastDiary) then
    thismonth = @diarys[0][0..5]
  elsif self.kind_of?(PastDiary) then
    thismonth = @targetMonth
  else
    return
  end

  y = thismonth[0..3].to_i
  m = thismonth[4..5].to_i

  ny = y
  nm = m + 1
  if nm > 12 then
    ny += 1
    nm  = 1
  end
  nextmonth = sprintf("%04d%02d", ny, nm)
  
  py = y
  pm = m - 1
  if pm < 1 then
    py -= 1
    pm  = 12
  end
  prevmonth = sprintf("%04d%02d", py, pm)
  
  if opt['lang'] == 'en' then
    wdayname = %w(Sun Mon Tue Wed Thu Fri Sat)
    mo  = Time::local(y,m).strftime("%Y/%m")
  else
    wdayname = %w(      y)
    mo  = Time::local(y,m).strftime2("%YN%m")
  end

  day = (1..28).to_a.concat((29..31).to_a.delete_if{ |d|
    !Date::exist?(y, m, d)
  }).collect!{ |d|
    d.to_s
  }

  1.upto(Time::local(y,m,1).wday){
    day.unshift("@")
  }

  5.downto(Time::local(y,m,day[-1]).wday){
    day.push("@")
  }
  
  str = "<table class=\"calendar\">\n"

  str << <<HTML_END
	<tr>
		<th colspan="7">#{mo}</th>
	</tr>
HTML_END

  str << "\t<tr>\n"
  for i in 0..6
    str << "\t\t<th>#{wdayname[i]}</th>\n"
  end
  str << "\t</tr>\n"

  while day.size != 0
    str << "\t<tr>\n"
    for i in 0..6
      d = day.shift
      dd = sprintf("%02d", d.to_i)
      if @allDiarys.key?(thismonth + dd) then
        str << "\t\t<td><a href=\"#{thismonth}#{@monthPartNames[dd.to_i]}.html##{dd}\">#{d}</a></td>\n"
      else
        str << "\t\t<td>#{d}</td>\n"
      end
    end
    str << "\t</tr>\n"
  end
  str << "</table>\n"

  return str

end
