;; ndiary-mode.el --- mode for editing ndiary's diary file
;; ISHIKURA Hiroyuki <neko@cc.rim.or.jp>
;; ----------------------------------------------------------------------
;; History:
;; 2000/03/29 ver.0.1  initial Release
;; 2000/04/16 ver.0.2  generic.el$B$r;H$o$J$$$h$&$KJQ99(B
;;                     .emacs$BFb$G(Bfont-lock$BDj5A$rJQ99!&DI2C$G$-$k$h$&$K$7$?(B
;; 2000/08/07 ver.0.21 ndiary-font-lock-keyword$B$r$A$g$$$H8+D>$7(B
;; 2000/09/10 ver.0.3  akihisa@alles.or.jp$B;a$N%3!<%I$r0lIt%^!<%8(B. 
;;                     $B$H$O$$$(;d$N<qL#$GBgI}$K=q$-$J$*$7$F$$$^$9(B (__)
;; 2000/09/14 ver.0.31 start-process$BA0$KF1L>$N(Bprocess$B$r(Bkill$B$9$k;v$K$7$?(B
;; 2000/09/25 ver.0.32 ndiary-preview$B$N$O$:$+$7$$%P%0$r=$@5(B
;; 2000/12/06 ver.0.33 ndiary-upload$B$G$O(Bcall-process$B$G=hM}$9$k$3$H$K$7$?(B
;;		       ($B%U%!%$%kE>Aw$r(Basync$B$G$d$k$N$O%"%l$+$J!A$H!D(B)
;;
;; TODO:
;; $B!&<+A0$N(Bface$BDj5A$r:n$k(B
;; $B!&(Bcustom$B$r;H$&(B
;; ----------------------------------------------------------------------
;; USAGE:
;; 1.$B$^$:(BnDiary$B$r;H$($k$h$&$K$-$A$s$H4D6-$r@0Hw$7$^$7$g$&(B. 
;;   $B$=$&$=$&!"(BRuby$B$K$bEvA3(BPATH$B$rDL$7$F$*$-$^$7$g$&(B :-)
;;
;; 2.APEL(http://www.m17n.org/APEL/)$B$r%$%s%9%H!<%k$7$^$7$g$&(B. Meadow$B$G$"(B
;;   $B$l$PI8=`$GF~$C$F$k$O$:$G$9$,!"$^$!:G?7HG$K$9$k$N$b0-$/$J$$$+$b$7$l(B
;;   $B$^$;$s(B :-)
;;
;; 3.$B$"$J$?$,$b$7(BMeadow$B$r;H$C$F$$$k$N$G$"$l$P!"(BMeadow$B$,(Bruby$B%9%/%j%W%H$r(B
;;   $BD>@\(Bstart-process$B$d(Bcall-process$B$G$-$k$h$&$K$9$k$?$a$K!"(B.emacs$B$K<!$N(B
;;   4$B9T$r=q$-B-$7$^$7$g$&(B. mw32script.el$B$rD>@\=q$-$+$($k$N$b2D$G$9(B.  
;;   $B!D$=$&$=$&!"(B1.$B$G(BRuby$B$K%Q%9$rDL$5$J$+$C$??M$O$3$3$G(Bruby$B$r%U%k%Q%9$K(B
;;   $B$9$kI,MW$,$"$j$^$9$M(B. 
;;       (require 'mw32script)
;;       (setq mw32script-argument-editing-alist
;;             (append '(("/ruby$" . "ruby.exe"))
;;                     mw32script-argument-editing-alist))
;;       (mw32script-init)
;;   $B$"$"!"(Bndiary-diary-command$B$K(BRuby$B%9%/%j%W%H$=$N$b$N$G$J$$J*(B(rb2c$B$r(B
;;   $B;H$C$F@8@.$7$?<B9T%U%!%$%k$H$+(B)$B$r;XDj$9$k$N$G$"$l$P!"$b$A$m$s$3$N(B
;;   $B5-=R$OI,MW$"$j$^$;$s!#(B
;;
;; 4.$B$"$J$?$N4D6-$K9g$&$h$&$K(B.emacs$B$NCf$G3F<o$N@_Dj$r9T$$$^$7$g$&(B. 
;;   $B$A$J$_$K;d$O<!$N$h$&$J@_Dj$rF~$l$F;H$C$F$$$^$9(B. 
;;       (require 'ndiary-mode)
;;       (setq ndiary-log-directory "~/diary/log")
;;       (setq ndiary-latest-filename "~/public_html/d/index.html")
;;       (setq ndiary-upload-command "sitecopy")
;;       (setq ndiary-upload-command-option "-u rim")
;;
;; 5.$B$3$l$G(BEmacs$B$rN)$A$"$2$J$*$;$P4pK\E*$K$O=`Hw40N;$G$9(B. 
;;   M-x ndiary-edit $B$GF|5-JT=8%b!<%I$KF~$j$^$9$7!"(B
;;   $B$3$N%b!<%I$G(BM-x ndiary-compile (C-cC-c) $B$9$l$P(Bhtml$B$,@8@.$5$l$^$9$7!"(B
;;   $B$3$N%b!<%I$G(BM-x ndiary-upload (C-cC-u) $B$9$l$P(Bupload$B$b$G$-$^$9(B. 
;;   ($B$"$"!"$b$A$m$s(Bupload$B$9$k%D!<%k$N@_Dj$O<+J,$G$d$C$F$/$@$5$$$M(B. :-p)
;; ----------------------------------------------------------------------

;; ndiary-mode requires APEL.
(require 'path-util)
(require 'alist)

;; $BDj?t(B
(defconst ndiary-mode-version "0.31" "ndiary-mode$B$N%P!<%8%g%s$r<($7$^$9(B.")

;; $B%+%9%?%^%$%:JQ?t72(B
(defvar ndiary-log-directory "~/diary/log"
  "$BF|5-$NCV$$$F$"$k%G%#%l%/%H%j(B.")
(defvar ndiary-latest-filename "~/public_html/d/index.html"
  "$B!V:G6a$NF|5-$N%@%$%8%'%9%H!W$N%U%!%$%kL>(B.")
(defvar ndiary-split-month t
  "$B7nKh$K(Bdiary$B%U%!%$%k$r:n@.$9$k%G%#%l%/%H%j$rJ,$1$k$+H]$+(B.")
(defvar ndiary-yesterday-time 2
  "$B$3$N;~4V(B(hour)$B$rD6$($k$^$G$OA0F|$H$7$F(Bdiary$B%U%!%$%k$r:n@.(B/$B<h$j$"$D$+$&(B.")
(defvar ndiary-diary-file-coding-system 'sjis-unix
  "ndiary-mode$B$G?75,:n@.$9$k(Bdiary$B%U%!%$%k$N(Bcoding-system.")
(defvar ndiary-mode-abbrev-table nil
  "ndiary-mode$B$G;H$o$l$k(Babbrev table.")
(defvar ndiary-diary-command "diary"
  "$BF|5-@8@.MQ$N%3%^%s%I(B. Emacs$B$,<B9T2DG=%U%!%$%k$G$"$kI,MW$,$"$k(B.")
(defvar ndiary-diary-command-option ""
  "$BF|5-@8@.MQ$N%3%^%s%I$N%*%W%7%g%s(B.")
(defvar ndiary-upload-command nil
  "$BF|5-%"%C%W%m!<%IMQ$N%3%^%s%I(B. Emacs$B$,<B9T2DG=%U%!%$%k$G$"$kI,MW$,$"$k(B.")
(defvar ndiary-upload-command-option ""
  "$BF|5-%"%C%W%m!<%IMQ$N%3%^%s%I$N%*%W%7%g%s(B.")

;; hooks
(defvar ndiary-mode-load-hook nil)
(defvar ndiary-edit-hook nil)
(defvar ndiary-pre-compile-hook nil
  "$BF|5-%U%!%$%k$r:n@.$9$kA0$K<B9T$5$l$k(Bhook.
text-adjust$B$NMQ$J%F%-%9%H@07AMQ(BLisp$B%Q%C%1!<%8$r;H$&$N$K;H$&(B.")
(defvar ndiary-aft-compile-hook nil
  "$BF|5-%U%!%$%k$r:n@.$7$?8e$K<B9T$5$l$k%U%!%$%k(B.")
(defvar ndiary-pre-upload-hook nil)
(defvar ndiary-aft-upload-hook nil)
(defvar ndiary-preview-hook nil)

(defvar ndiary-font-lock-keywords
  '(("\\(^$B"#(B\\|^$B!{(B\\|^$B!}(B\\|^$B""(B\\|^$B!~(B\\|^$B"!(B\
\\|^$B"$(B\\|^$B"%(B\\|^$B"&(B\\|^$B"'(B\\|^$B!y(B\\|^$B!z(B\\)\\(.*\\)"
     (1 font-lock-type-face)
     (2 font-lock-function-name-face))
    ("^\\($B!&(B\\)\\(.*\\)$"
     (1 font-lock-warning-face)
     (2 font-lock-function-name-face))
    ("^\\(Code:\\( -.*\\)?\\|^<<\\)$"
     (0 font-lock-warning-face))
    ("(\\*[^)]*)"
     (0 font-lock-comment-face))
    ("<[^>]*>"
     (0 font-lock-keyword-face)))
  "ndiary-mode$BMQ$N(Bfont-lock-keywords.")

(defun ndiary-mode ()
  "nDiary$B%U%!%$%k$rJT=8$9$k$?$a$N(BMajor mode.
private-abbrev-table$B$H!"0J2<$N%-!<%P%$%s%I$rDs6!$7$^$9(B:

\\[ndiary-compile]\t$BF|5-$r@8@.$9$k%3%^%s%I$r8F$S=P$9(B.
\\[ndiary-encode-region]\tregion$BFb$N(B\"<, >, &\"$B$r!"$=$l$>$l(B\"&lt; &gt; &amp;\"$B$K%(%s%3!<%I$9$k(B.
\\[ndiary-upload]\t$BF|5-$r%"%C%W%m!<%I$9$k%3%^%s%I$r8F$S=P$9(B.
\\[ndiary-preview]\tbrowse-url$B$r;H$C$FF|5-$r(Bpreview$B$9$k(B."
  (interactive)
  (kill-all-local-variables)
  (setq mode-name "nDiary")
  (setq major-mode 'ndiary-mode)
  (make-local-variable 'font-lock-keywords-only)
  (setq font-lock-keywords-only t)
  (make-local-variable 'font-lock-defaults)
  (setq font-lock-defaults '(ndiary-font-lock-keywords))
  (setq buffer-file-coding-system ndiary-diary-file-coding-system)
  (setq local-abbrev-table ndiary-mode-abbrev-table)
  (abbrev-mode t)
  (local-set-key "\C-c\C-c" 'ndiary-compile)
  (local-set-key "\C-ce" 'ndiary-encode-region)
  (local-set-key "\C-cu" 'ndiary-upload)
  (local-set-key "\C-cp" 'ndiary-preview)
  (run-hooks 'ndiary-mode-hook))

(defun ndiary-encode-region ()		; < > &
  "$B%j!<%8%g%sFb$N(B\"<, >, &\"$B$r!"(B\
$B$=$l$>$l(B\"&lt; &gt; &amp;\"$B$K%(%s%3!<%I$7$^$9(B."
  (interactive)
  (let (end-point (head-pointp (< (point) (mark))))
    (or head-pointp (exchange-point-and-mark))
    (save-excursion
      (while (re-search-forward "[<>&]" (mark) t)
	(let (tl)
	  (setq tl (buffer-substring (match-beginning 0) (match-end 0)))
	  (cond ((string= tl "<") (replace-match "&lt;"))
		((string= tl ">") (replace-match "&gt;"))
		((string= tl "&") (replace-match "&amp;"))))))))

(defun ndiary-edit ()
  "$B:#F|$NF|5-%U%!%$%k$rJT=8$7$^$9(B."
  (interactive)
  (let ((now (current-time)) dateh datel dir)
    ;; ndiary-yesterday-time$B$^$G$OA0F|$H$7$F07$&(B
    (setq dateh (nth 0 now))
    (setq datel (- (nth 1 now) (* ndiary-yesterday-time 3600)))
    (if (< datel 0)
	(progn
	  (setq datel (+ datel 65536))
	  (setq dateh (1- dateh))))
    (setq now (list dateh datel))

    ;; ndiary-log-directory$B$,%"%/%;%9ITG=$J$i$*$7$^$$(B
    (if (not (file-accessible-directory-p ndiary-log-directory))
	(error "ndiary-log-directory$B$N@_Dj$,%X%s$8$c$J$$$G$9$+(B?"))

    ;; $BF|5-$N%U%!%$%kL>$r7hDj$9$k(B
    (cond
     ((eq ndiary-split-month t)
      (setq dir (expand-file-name
		 (format-time-string "%Y/%m" now) ndiary-log-directory))
      (if (not (file-accessible-directory-p dir))
	  (make-directory dir t)))
     (t
      (setq dir ndiary-log-directory)))

    ;; $B%P%C%U%!$r:n$k(B
    (setq ndiary-file-name (expand-file-name 
			    (format-time-string "%Y%m%d.diary" now) dir))
    (setq ndiary-buffer (find-file ndiary-file-name)))
  (run-hooks 'ndiary-edit-hook))

(defun ndiary-compile (arg)
  "$BF|5-@8@.%3%^%s%I$rH/9T$7$F(Bhtml$B%U%!%$%k$r@8@.$9$k(B.
C-u ndiary-compile $B$H$9$k$H(B diary $B$KM?$($k%*%W%7%g%s$r;XDj$G$-$k(B."
  (interactive "P")
  (let ((com ndiary-diary-command)
	(opt ndiary-diary-command-option))
    (run-hooks 'ndiary-pre-compile-hook)
    (ndiary-save-buffers)    ;; $B<B9TA0$K(Bndiary$B4XO"%P%C%U%!$rA4$F%;!<%V$9$k!#(B
    (if (not (exec-installed-p ndiary-diary-command))
	(error "ndiary-diary-command$B$,@5$7$/@_Dj$5$l$F$$$J$$$h$&$G$9(B."))
    (if arg
	(setq com (read-from-minibuffer "diary command: " com)
	      opt (read-from-minibuffer "diary command option: " opt)))
    (save-excursion
      (set-buffer (get-buffer-create "*ndiary-compile*"))
      (if (get-process "ndiary-compile")
	  (progn
	    (delete-process "ndiary-compile")))
      (erase-buffer)
      (apply (function start-process)
	     "ndiary-compile" "*ndiary-compile*" com (split-string opt))
      (display-buffer "*ndiary-compile*"))
    (run-hooks 'ndiary-aft-compile-hook)))

(defun ndiary-upload (arg)
  "upload$BMQ%3%^%s%I(B(sitecopy$BEy(B)$B$rH/9T$7$FF|5-$r(Bupload$B$9$k(B."
  (interactive "P")
  (let ((com ndiary-upload-command)
	(opt ndiary-upload-command-option))
    (run-hooks 'ndiary-pre-upload-hook)
    (if (not (exec-installed-p com))
	(error "ndiary-upload-command$B$,@5$7$/@_Dj$5$l$F$$$J$$$h$&$G$9(B."))
    (if arg
	(setq com (read-from-minibuffer "upload command: " com)
	      opt (read-from-minibuffer "upload command option: " opt)))
    (save-excursion
      (set-buffer (get-buffer-create "*ndiary-upload*"))
      (erase-buffer)
      (display-buffer "*ndiary-upload*"))
      (apply (function call-process)
	     com nil "*ndiary-upload*" t (split-string opt))
    (run-hooks 'ndiary-aft-upload-hook)))

(defun ndiary-preview (arg)
  "latest diary file$B$r(Bpreview$B$7$^$9!#(B"
  (interactive "P")
  (let ((filename ndiary-latest-filename))
    (run-hooks 'ndiary-preview-hook)
    (if arg
	(setq filename (read-from-minibuffer "preview file: "
					     ndiary-latest-filename)))
    (setq filename (expand-file-name filename))
    (if (file-readable-p filename)
	(browse-url-of-file filename)
      (error "$B;XDj$5$l$?%U%!%$%k$OB8:_$7$J$$$h$&$G$9$,!D(B."))))

(defun ndiary-save-buffers ()
  "Save buffers whose major-mode is equal to current major-mode."
  (basic-save-buffer)
  (let ((cmm 'ndiary-mode))
    (save-excursion
      (mapcar '(lambda (buf)
		 (set-buffer buf)
		 (if (and (buffer-file-name buf)
			  (eq major-mode cmm)
			  (buffer-modified-p buf)
			  (y-or-n-p (format "Save %s" (buffer-name buf))))
		     (save-buffer buf)))
	      (buffer-list)))))

(setq auto-mode-alist
      (modify-alist '(("\\.diary\\'" . ndiary-mode))
		    auto-mode-alist))
(run-hooks 'ndiary-mode-load-hook)

(provide 'ndiary-mode)
